<?php


abstract class BaseRegionalesPeer {

	
	const DATABASE_NAME = 'propel';

	
	const TABLE_NAME = 'REGIONALES';

	
	const CLASS_DEFAULT = 'lib.model.Regionales';

	
	const NUM_COLUMNS = 10;

	
	const NUM_LAZY_LOAD_COLUMNS = 0;


	
	const CODREG = 'REGIONALES.CODREG';

	
	const DESREG = 'REGIONALES.DESREG';

	
	const CIUCED = 'REGIONALES.CIUCED';

	
	const DEPARTA = 'REGIONALES.DEPARTA';

	
	const DIRECCION = 'REGIONALES.DIRECCION';

	
	const CODDEP = 'REGIONALES.CODDEP';

	
	const CODMUN = 'REGIONALES.CODMUN';

	
	const NITCAJA = 'REGIONALES.NITCAJA';

	
	const CODCAJ = 'REGIONALES.CODCAJ';

	
	const RAZSOC = 'REGIONALES.RAZSOC';

	
	private static $phpNameMap = null;


	
	private static $fieldNames = array (
		BasePeer::TYPE_PHPNAME => array ('Codreg', 'Desreg', 'Ciuced', 'Departa', 'Direccion', 'Coddep', 'Codmun', 'Nitcaja', 'Codcaj', 'Razsoc', ),
		BasePeer::TYPE_COLNAME => array (RegionalesPeer::CODREG, RegionalesPeer::DESREG, RegionalesPeer::CIUCED, RegionalesPeer::DEPARTA, RegionalesPeer::DIRECCION, RegionalesPeer::CODDEP, RegionalesPeer::CODMUN, RegionalesPeer::NITCAJA, RegionalesPeer::CODCAJ, RegionalesPeer::RAZSOC, ),
		BasePeer::TYPE_FIELDNAME => array ('CODREG', 'DESREG', 'CIUCED', 'DEPARTA', 'DIRECCION', 'CODDEP', 'CODMUN', 'NITCAJA', 'CODCAJ', 'RAZSOC', ),
		BasePeer::TYPE_NUM => array (0, 1, 2, 3, 4, 5, 6, 7, 8, 9, )
	);

	
	private static $fieldKeys = array (
		BasePeer::TYPE_PHPNAME => array ('Codreg' => 0, 'Desreg' => 1, 'Ciuced' => 2, 'Departa' => 3, 'Direccion' => 4, 'Coddep' => 5, 'Codmun' => 6, 'Nitcaja' => 7, 'Codcaj' => 8, 'Razsoc' => 9, ),
		BasePeer::TYPE_COLNAME => array (RegionalesPeer::CODREG => 0, RegionalesPeer::DESREG => 1, RegionalesPeer::CIUCED => 2, RegionalesPeer::DEPARTA => 3, RegionalesPeer::DIRECCION => 4, RegionalesPeer::CODDEP => 5, RegionalesPeer::CODMUN => 6, RegionalesPeer::NITCAJA => 7, RegionalesPeer::CODCAJ => 8, RegionalesPeer::RAZSOC => 9, ),
		BasePeer::TYPE_FIELDNAME => array ('CODREG' => 0, 'DESREG' => 1, 'CIUCED' => 2, 'DEPARTA' => 3, 'DIRECCION' => 4, 'CODDEP' => 5, 'CODMUN' => 6, 'NITCAJA' => 7, 'CODCAJ' => 8, 'RAZSOC' => 9, ),
		BasePeer::TYPE_NUM => array (0, 1, 2, 3, 4, 5, 6, 7, 8, 9, )
	);

	
	public static function getMapBuilder()
	{
		return BasePeer::getMapBuilder('lib.model.map.RegionalesMapBuilder');
	}
	
	public static function getPhpNameMap()
	{
		if (self::$phpNameMap === null) {
			$map = RegionalesPeer::getTableMap();
			$columns = $map->getColumns();
			$nameMap = array();
			foreach ($columns as $column) {
				$nameMap[$column->getPhpName()] = $column->getColumnName();
			}
			self::$phpNameMap = $nameMap;
		}
		return self::$phpNameMap;
	}
	
	static public function translateFieldName($name, $fromType, $toType)
	{
		$toNames = self::getFieldNames($toType);
		$key = isset(self::$fieldKeys[$fromType][$name]) ? self::$fieldKeys[$fromType][$name] : null;
		if ($key === null) {
			throw new PropelException("'$name' could not be found in the field names of type '$fromType'. These are: " . print_r(self::$fieldKeys[$fromType], true));
		}
		return $toNames[$key];
	}

	

	static public function getFieldNames($type = BasePeer::TYPE_PHPNAME)
	{
		if (!array_key_exists($type, self::$fieldNames)) {
			throw new PropelException('Method getFieldNames() expects the parameter $type to be one of the class constants TYPE_PHPNAME, TYPE_COLNAME, TYPE_FIELDNAME, TYPE_NUM. ' . $type . ' was given.');
		}
		return self::$fieldNames[$type];
	}

	
	public static function alias($alias, $column)
	{
		return str_replace(RegionalesPeer::TABLE_NAME.'.', $alias.'.', $column);
	}

	
	public static function addSelectColumns(Criteria $criteria)
	{

		$criteria->addSelectColumn(RegionalesPeer::CODREG);

		$criteria->addSelectColumn(RegionalesPeer::DESREG);

		$criteria->addSelectColumn(RegionalesPeer::CIUCED);

		$criteria->addSelectColumn(RegionalesPeer::DEPARTA);

		$criteria->addSelectColumn(RegionalesPeer::DIRECCION);

		$criteria->addSelectColumn(RegionalesPeer::CODDEP);

		$criteria->addSelectColumn(RegionalesPeer::CODMUN);

		$criteria->addSelectColumn(RegionalesPeer::NITCAJA);

		$criteria->addSelectColumn(RegionalesPeer::CODCAJ);

		$criteria->addSelectColumn(RegionalesPeer::RAZSOC);

	}

	const COUNT = 'COUNT(REGIONALES.CODREG)';
	const COUNT_DISTINCT = 'COUNT(DISTINCT REGIONALES.CODREG)';

	
	public static function doCount(Criteria $criteria, $distinct = false, $con = null)
	{
				$criteria = clone $criteria;

				$criteria->clearSelectColumns()->clearOrderByColumns();
		if ($distinct || in_array(Criteria::DISTINCT, $criteria->getSelectModifiers())) {
			$criteria->addSelectColumn(RegionalesPeer::COUNT_DISTINCT);
		} else {
			$criteria->addSelectColumn(RegionalesPeer::COUNT);
		}

				foreach($criteria->getGroupByColumns() as $column)
		{
			$criteria->addSelectColumn($column);
		}

		$rs = RegionalesPeer::doSelectRS($criteria, $con);
		if ($rs->next()) {
			return $rs->getInt(1);
		} else {
						return 0;
		}
	}
	
	public static function doSelectOne(Criteria $criteria, $con = null)
	{
		$critcopy = clone $criteria;
		$critcopy->setLimit(1);
		$objects = RegionalesPeer::doSelect($critcopy, $con);
		if ($objects) {
			return $objects[0];
		}
		return null;
	}
	
	public static function doSelect(Criteria $criteria, $con = null)
	{
		return RegionalesPeer::populateObjects(RegionalesPeer::doSelectRS($criteria, $con));
	}
	
	public static function doSelectRS(Criteria $criteria, $con = null)
	{
		if ($con === null) {
			$con = Propel::getConnection(self::DATABASE_NAME);
		}

		if (!$criteria->getSelectColumns()) {
			$criteria = clone $criteria;
			RegionalesPeer::addSelectColumns($criteria);
		}

				$criteria->setDbName(self::DATABASE_NAME);

						return BasePeer::doSelect($criteria, $con);
	}
	
	public static function populateObjects(ResultSet $rs)
	{
		$results = array();
	
				$cls = RegionalesPeer::getOMClass();
		$cls = sfPropel::import($cls);
				while($rs->next()) {
		
			$obj = new $cls();
			$obj->hydrate($rs);
			$results[] = $obj;
			
		}
		return $results;
	}

  static public function getUniqueColumnNames()
  {
    return array();
  }
	
	public static function getTableMap()
	{
		return Propel::getDatabaseMap(self::DATABASE_NAME)->getTable(self::TABLE_NAME);
	}

	
	public static function getOMClass()
	{
		return RegionalesPeer::CLASS_DEFAULT;
	}

	
	public static function doInsert($values, $con = null)
	{
		if ($con === null) {
			$con = Propel::getConnection(self::DATABASE_NAME);
		}

		if ($values instanceof Criteria) {
			$criteria = clone $values; 		} else {
			$criteria = $values->buildCriteria(); 		}


				$criteria->setDbName(self::DATABASE_NAME);

		try {
									$con->begin();
			$pk = BasePeer::doInsert($criteria, $con);
			$con->commit();
		} catch(PropelException $e) {
			$con->rollback();
			throw $e;
		}

		return $pk;
	}

	
	public static function doUpdate($values, $con = null)
	{
		if ($con === null) {
			$con = Propel::getConnection(self::DATABASE_NAME);
		}

		$selectCriteria = new Criteria(self::DATABASE_NAME);

		if ($values instanceof Criteria) {
			$criteria = clone $values; 
			$comparison = $criteria->getComparison(RegionalesPeer::CODREG);
			$selectCriteria->add(RegionalesPeer::CODREG, $criteria->remove(RegionalesPeer::CODREG), $comparison);

		} else { 			$criteria = $values->buildCriteria(); 			$selectCriteria = $values->buildPkeyCriteria(); 		}

				$criteria->setDbName(self::DATABASE_NAME);

		return BasePeer::doUpdate($selectCriteria, $criteria, $con);
	}

	
	public static function doDeleteAll($con = null)
	{
		if ($con === null) {
			$con = Propel::getConnection(self::DATABASE_NAME);
		}
		$affectedRows = 0; 		try {
									$con->begin();
			$affectedRows += BasePeer::doDeleteAll(RegionalesPeer::TABLE_NAME, $con);
			$con->commit();
			return $affectedRows;
		} catch (PropelException $e) {
			$con->rollback();
			throw $e;
		}
	}

	
	 public static function doDelete($values, $con = null)
	 {
		if ($con === null) {
			$con = Propel::getConnection(RegionalesPeer::DATABASE_NAME);
		}

		if ($values instanceof Criteria) {
			$criteria = clone $values; 		} elseif ($values instanceof Regionales) {

			$criteria = $values->buildPkeyCriteria();
		} else {
						$criteria = new Criteria(self::DATABASE_NAME);
			$criteria->add(RegionalesPeer::CODREG, (array) $values, Criteria::IN);
		}

				$criteria->setDbName(self::DATABASE_NAME);

		$affectedRows = 0; 
		try {
									$con->begin();
			
			$affectedRows += BasePeer::doDelete($criteria, $con);
			$con->commit();
			return $affectedRows;
		} catch (PropelException $e) {
			$con->rollback();
			throw $e;
		}
	}

	
	public static function doValidate(Regionales $obj, $cols = null)
	{
		$columns = array();

		if ($cols) {
			$dbMap = Propel::getDatabaseMap(RegionalesPeer::DATABASE_NAME);
			$tableMap = $dbMap->getTable(RegionalesPeer::TABLE_NAME);

			if (! is_array($cols)) {
				$cols = array($cols);
			}

			foreach($cols as $colName) {
				if ($tableMap->containsColumn($colName)) {
					$get = 'get' . $tableMap->getColumn($colName)->getPhpName();
					$columns[$colName] = $obj->$get();
				}
			}
		} else {

		}

		$res =  BasePeer::doValidate(RegionalesPeer::DATABASE_NAME, RegionalesPeer::TABLE_NAME, $columns);
    if ($res !== true) {
        $request = sfContext::getInstance()->getRequest();
        foreach ($res as $failed) {
            $col = RegionalesPeer::translateFieldname($failed->getColumn(), BasePeer::TYPE_COLNAME, BasePeer::TYPE_PHPNAME);
            $request->setError($col, $failed->getMessage());
        }
    }

    return $res;
	}

	
	public static function retrieveByPK($pk, $con = null)
	{
		if ($con === null) {
			$con = Propel::getConnection(self::DATABASE_NAME);
		}

		$criteria = new Criteria(RegionalesPeer::DATABASE_NAME);

		$criteria->add(RegionalesPeer::CODREG, $pk);


		$v = RegionalesPeer::doSelect($criteria, $con);

		return !empty($v) > 0 ? $v[0] : null;
	}

	
	public static function retrieveByPKs($pks, $con = null)
	{
		if ($con === null) {
			$con = Propel::getConnection(self::DATABASE_NAME);
		}

		$objs = null;
		if (empty($pks)) {
			$objs = array();
		} else {
			$criteria = new Criteria();
			$criteria->add(RegionalesPeer::CODREG, $pks, Criteria::IN);
			$objs = RegionalesPeer::doSelect($criteria, $con);
		}
		return $objs;
	}

} 
if (Propel::isInit()) {
			try {
		BaseRegionalesPeer::getMapBuilder();
	} catch (Exception $e) {
		Propel::log('Could not initialize Peer: ' . $e->getMessage(), Propel::LOG_ERR);
	}
} else {
			Propel::registerMapBuilder('lib.model.map.RegionalesMapBuilder');
}
